VERSION 5.00
Begin VB.Form frmZoom 
   BackColor       =   &H00000000&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Zoom"
   ClientHeight    =   5490
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6240
   ControlBox      =   0   'False
   Icon            =   "frmZoom.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5490
   ScaleWidth      =   6240
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.Image imgZoom 
      Height          =   1335
      Left            =   360
      Top             =   480
      Width           =   1335
   End
End
Attribute VB_Name = "frmZoom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'******* 01.20a Start *******
Private mintZoomClicks As Integer
Private Const ZOOM_PCT = 0.2 ' If the ZOOM_PCT is changed MAX_ZOOMS will also need to change
Private Const MAX_ZOOMS = 15

Private Type ImageDimensions
    ImageWidth As Single
    imageHeight As Single
End Type
Private mDimensions() As ImageDimensions
'******* 01.20a End *********
Private Sub Form_Activate()

    Dim dblRatio As Double
    Dim lngNewLeft As Long
    Dim lngNewTop As Long
    Dim lngNewWidth As Long
    Dim lngNewHeight As Long
    
    '******* 01.50f Start *******
    Me.Caption = ShortenCaption(frmZoom, App.EXEName & " Zoom - " & mcolPictures(CStr(gintCurrentPic)).PicName)
    '******* 01.50f End *********

    ' When set to False the graphic doesn't change size but the image container does
    imgZoom.Stretch = False
    ' so this will make imgZoom the size of the picture
    imgZoom.Picture = LoadPicture(mcolPictures(CStr(gintCurrentPic)).PicName)
    dblRatio = imgZoom.Width / imgZoom.Height

    Select Case True
        Case imgZoom.Height > imgZoom.Container.ScaleHeight
            ' Image is too tall
            lngNewTop = 0
            lngNewWidth = imgZoom.Container.ScaleHeight * dblRatio
            lngNewLeft = (imgZoom.Container.ScaleWidth - lngNewWidth) / 2
            lngNewHeight = imgZoom.Container.ScaleHeight
        Case imgZoom.Width > imgZoom.Container.ScaleWidth
            ' Image is too wide
            lngNewLeft = 0
            lngNewTop = (imgZoom.Container.ScaleHeight - lngNewHeight) / 2
            lngNewWidth = imgZoom.Container.ScaleWidth
            lngNewHeight = lngNewWidth / dblRatio
        Case Else
            ' It fits so just center it
            lngNewTop = (imgZoom.Container.ScaleHeight - imgZoom.Height) / 2
            lngNewWidth = imgZoom.Width
            lngNewLeft = (imgZoom.Container.ScaleWidth - imgZoom.Width) / 2
            lngNewHeight = imgZoom.Height
    End Select

    imgZoom.Stretch = True
    imgZoom.Move lngNewLeft, lngNewTop, lngNewWidth, lngNewHeight
    
    '******* 01.20a Start *******
'    imgZoom.ToolTipText = "Left click = zoom in, right click = zoom out, press Esc to return"
    imgZoom.ToolTipText = "Left click = zoom in, right click = zoom out, Ctrl_R = re-center, and Esc = return"
    
    '******* 01.40i Start *******
'    Me.MouseIcon = LoadPicture(App.Path & "\graphics\magnify.cur")
    Me.MouseIcon = LoadResPicture(curMagnify, vbResCursor)
    '******* 01.40i End *********
    Me.MousePointer = vbCustom
    '******* 01.20a End *********

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    '******* 01.20a Start *******
    Dim ShiftTest As Integer
    '******* 01.20a End *********
    
    If KeyCode = vbKeyEscape Then
        Unload Me
        frmDisplay.Show
    End If
 
    '******* 01.20a Start *******
    ShiftTest = Shift And 7
    If ShiftTest = vbCtrlMask Then
        If KeyCode = vbKeyR Then
        ' Recenter the image via Ctrl_R
            imgZoom.Move (imgZoom.Container.ScaleWidth - imgZoom.Width) / 2, _
                          (imgZoom.Container.ScaleHeight - imgZoom.Height) / 2
        End If
    End If
    '******* 01.20a End *********

End Sub

Private Sub Form_Load()

    '******* 01.50f Start *******
    'Me.Caption = App.EXEName & " Zoom - " & mcolPictures(CStr(gintCurrentPic)).PicName
    '******* 01.50f End *********
    
    '******* 01.20a Start *******
    ' Initialize zoom parameters
    mintZoomClicks = 0
    ReDim mDimensions(1 To 15) As ImageDimensions
    '******* 01.20a End *********

End Sub


Private Sub imgZoom_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim lngNewLeft As Long
    Dim lngNewTop As Long
    Dim lngNewWidth As Long
    Dim lngNewHeight As Long
    Dim dblZoomAmt As Double
    Dim dblZoomPct As Double
    '******* 01.20a Start *******
    Dim sngRatio As Single
    
    ' Calculate the height/width ratio
    sngRatio = imgZoom.Height / imgZoom.Width
    '******* 01.20a End *********
    
    ' Calculate the zoom amount
    dblZoomAmt = imgZoom.Width * ZOOM_PCT
    
    If Button = vbLeftButton Then
        ' Zoom in
        '******* 01.20a Start *******
        ' The width was increased so move the image left 1/2 of the
        ' zoom amount to keep it "centered"
'        lngNewLeft = (imgZoom.Left - dblZoomAmt / 2)

        ' center it vertically
'        lngNewTop = (imgZoom.Container.ScaleHeight - lngNewHeight) / 2
        ' After 15 zooms the screen goes crazy
        If mintZoomClicks = MAX_ZOOMS Then
            Exit Sub
        Else
            mintZoomClicks = mintZoomClicks + 1
        End If
        
        mDimensions(mintZoomClicks).ImageWidth = imgZoom.Width
        mDimensions(mintZoomClicks).imageHeight = imgZoom.Height
        
        lngNewWidth = imgZoom.Width + dblZoomAmt
        lngNewHeight = lngNewWidth * sngRatio
        '******* 01.20a End *********
    ElseIf Button = vbRightButton Then
        ' Zoom out
        '******* 01.20a Start *******
'        lngNewWidth = imgZoom.Width - dblZoomAmt
        ' The width was decreased so move the image right 1/2 of the
        ' zoom amount to keep it "centered"
'        lngNewLeft = imgZoom.Left + dblZoomAmt / 2
'        lngNewTop = (imgZoom.Container.ScaleHeight - lngNewHeight) / 2
        ' Don't let the size decrease below the original
        If mintZoomClicks = 0 Then
            Exit Sub
        End If
        
        ' Restore the previous size
        lngNewWidth = mDimensions(mintZoomClicks).ImageWidth
        lngNewHeight = mDimensions(mintZoomClicks).imageHeight
        mintZoomClicks = mintZoomClicks - 1
        '******* 01.20a End *********

    End If
    
    ' Change the height by the same ratio as the width
    '******* 01.20a Start *******
'    lngNewHeight = imgZoom.Height * lngNewWidth / imgZoom.Width
    ' Center it on the spot that was clicked
    dblZoomPct = lngNewWidth / imgZoom.Width
    lngNewLeft = (imgZoom.Container.ScaleWidth \ 2) - (X * dblZoomPct)
    lngNewTop = (imgZoom.Container.ScaleHeight \ 2) - (Y * dblZoomPct)
    '******* 01.20a End *********

    imgZoom.Move lngNewLeft, lngNewTop, lngNewWidth, lngNewHeight

End Sub
